#include "stdafx.h"
#include "windows.h"
#include "stdio.h"
#include "hwinterfacedrv.h"
#include "iostream.h"

void outport(int PortAddress, int data);
int inport(int PortAddress);

HANDLE hdriver;


int Opendriver(void);
void Closedriver(void);

int main(int argc, char* argv[])
{
Opendriver();
//outport(0x378+2,0xff);
cout << inport(0x378);
CloseHandle(hdriver);
return 0;
}



int Opendriver(void)
{
    hdriver = CreateFile("\\\\.\\hwinterface", 
                                 GENERIC_READ | GENERIC_WRITE, 
                                 0, 
                                 NULL,
                                 OPEN_EXISTING, 
                                 FILE_ATTRIBUTE_NORMAL, 
                                 NULL);
	
	if(hdriver == INVALID_HANDLE_VALUE) 
		{
		return 1;
		}
return 0;
}

void Closedriver(void)
{
    CloseHandle(hdriver);
}

void outport(int PortAddress, int data)
{
    unsigned int error;
    DWORD BytesReturned;        
    BYTE Buffer[3];
    unsigned short * pBuffer;
    pBuffer = (unsigned short *)&Buffer[0];
    *pBuffer = LOWORD(PortAddress);
    Buffer[2] = LOBYTE(data);

    error = DeviceIoControl(hdriver,
                            IOCTL_WRITE_PORT_UCHAR,
                            &Buffer,
                            3,
                            NULL,
                            0,
                            &BytesReturned,
                            NULL);

    if (!error)
	{
printf("Error %d\n",GetLastError());
	}
	
}


int inport(int PortAddress)
{
    unsigned int error;
    DWORD BytesReturned;
    unsigned char Buffer[3];
    unsigned short * pBuffer;
    pBuffer = (unsigned short *)&Buffer;
    *pBuffer = LOWORD(PortAddress);
	Buffer[2] = 0;
    error = DeviceIoControl(hdriver,
                            IOCTL_READ_PORT_UCHAR,
                            &Buffer,
                            2,
                            &Buffer,
                            1,
                            &BytesReturned,
                            NULL);

    if (!error) printf("Error %d\n",GetLastError());
    return((int)Buffer[0]);
}